<?php
/**
Checkout shipping information form

DO NOT REMOVE THE TEMPLATE VERSION NUMBER! 
Version: 3.1.19

 */
global $ign_opc, $user_ID;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( function_exists( 'wc_ship_to_billing_address_only' ) )
	$ship_to_billing_address_only = wc_ship_to_billing_address_only();
else 
	$ship_to_billing_address_only = WC()->cart->ship_to_billing_address_only();
	
if ( empty( $checkout ) ) {
	$checkout = WC()->checkout;
}
?>
<div class="woocommerce-shipping-fields">

	<?php
		if ( empty( $_POST ) || isset( $_POST['opc_customer_selected'] ) ) {
			$ship_to_different_address = get_option( 'woocommerce_ship_to_destination' ) === 'shipping' ? true : false;
			$ship_to_different_address = apply_filters( 'woocommerce_ship_to_different_address_checked', $ship_to_different_address );

		} else {
			$ship_to_different_address = $checkout->get_value( 'ship_to_different_address' );
		}
	?>

	<h3 id="ship-to-different-address">
		<label for="ship-to-different-address-checkbox" class="checkbox"><?php _e( 'Ship to a different address?', 'manual_phone_orders' ); ?></label>
		<input id="ship-to-different-address-checkbox" class="input-checkbox" <?php checked( $ship_to_different_address, 1 ); ?> type="checkbox" name="ship_to_different_address" value="1" />
	</h3>

	<div class="shipping_address">

		<?php 
		// Ensure the correct user account is loaded and WC loads a customer object for that user
		if ( !empty( $_REQUEST['one_page_customer_user'] ) ) {
			$ign_opc->switch_user_context_to_customer( 'customer' );
			WC()->customer = new WC_Customer( $user_ID ); 
		}
		?>
		
		<?php 
		do_action( 'woocommerce_before_checkout_shipping_form', $checkout ); 
		
		//$checkout->checkout_fields = apply_filters( 'ignitewoo_manual_phone_orders_shipping_fields', $checkout->checkout_fields );
		
		if ( !empty( $_REQUEST['one_page_customer_user'] ) ) { 
			$first_name = get_user_meta( absint( $_REQUEST['one_page_customer_user'] ), 'billing_first_name', true );
		}
		?>

		<?php foreach ( $checkout->checkout_fields['shipping'] as $key => $field ) : ?>

			<?php 

			// Make sure when "Guest" is selected the form fields are emptied
			if ( empty( $_REQUEST['one_page_customer_user'] ) )
				$val = '';
				
			// Or if the user has no billing info leave fields empty
			else if ( !empty( $_REQUEST['one_page_customer_user'] ) && false == $first_name )
				$val = '';
			else 
				$val = $checkout->get_value( $key );

			$default = !empty( $ign_opc_core->settings['default_country'] ) ? explode( ':', $ign_opc_core->settings['default_country'] ) : array();

			if ( empty( $val ) && !empty( $_POST[ $key ] ) )
				$val = $_POST[ $key ];
			else if ( empty( $val ) && 'billing_state' == $key ) 
				$val = !empty( $default[1] ) ? $default[1] : 'TX';
			else if ( empty( $val ) && 'billing_country' == $key ) 
				$val = !empty( $default[0] ) ? $default[0] : 'US';
				
			woocommerce_form_field( $key, $field, $val );
			
			?>

		<?php endforeach; ?>
		
		<?php 
			// Switch back to the currently logged in user
			$ign_opc->switch_user_context_to_customer( 'opc_user' ); 
			WC()->customer = new WC_Customer( $user_ID ); 
		?>

		<?php do_action( 'woocommerce_after_checkout_shipping_form', $checkout ); ?>

	</div>


	<?php do_action( 'woocommerce_before_order_notes', $checkout ); ?>

	<?php if ( apply_filters( 'woocommerce_enable_order_notes_field', get_option( 'woocommerce_enable_order_comments', 'yes' ) === 'yes' ) ) : ?>

		<?php if ( ! WC()->cart->needs_shipping() || $ship_to_billing_address_only ) : ?>

			<h3><?php _e( 'Additional Information', 'manual_phone_orders' ); ?></h3>

		<?php endif; ?>

		<?php 
		$checkout_fields = array(); 
		$checkout_fields['order'] = $checkout->checkout_fields['order'];
		$checkout_fields['order'] = apply_filters( 'ignitewoo_manual_phone_orders_order_fields', $checkout_fields['order'] );
		?>
		
		<?php if ( !empty( $checkout_fields['order'] ) ) foreach ( $checkout_fields['order'] as $key => $field ) : ?>

			<?php 
				$loaded_order_id = WC()->session->get( 'phone_manual_order_loaded_id' );
				
				$o = false; 
				
				if ( !empty( $loaded_order_id ) ) { 
					$o = wc_get_order( $loaded_order_id );
				}

				$notes = !empty( $o ) ? $o->get_customer_note() : $checkout->get_value( $key );
				
				woocommerce_form_field( $key, $field, $notes ); 

			?>

		<?php endforeach; ?>

	<?php endif; ?>

	<?php do_action( 'woocommerce_after_order_notes', $checkout ); ?>
</div>
