<?php
/* 
Manual/Phone Order template - Table layout for controlling the list of products

Copyright (c) 2014, 2020 - IgniteWoo.com

IgniteWoo does not provide support for customizations!
-----------------------------------------------------

DO NOT REMOVE THE TEMPLATE VERSION NUMBER! 

Version: 3.1.19
*/


global $cart_products, $display_images, $ign_opc, $ign_opc_core, $user_ID, $ign_wholesale_pro_suite;

if ( empty( $cart_products ) ) { 
	
	?>
	<p class="opc_cart_is_empty"><?php _e( 'The cart is currently empty', 'manual_phone_orders' )?></p>
	
	<?php
	
	return;
	
}
	

/* ***** NOTES ******

"$display_images = false" will display the display of product thumbnails

ARRAY DATA LAYOUT: 

$_product['data'] - contains the product object as set by WooCommerce get_product()

$_product['attrs'] - contains any visible attributes or variation attributes for the product. This is used to display a list of attribute names/values

$_product['url_parms'] - contains a formatted name/value pair string of attributes for a product variation

******************* */
?>
<style>
.one_page_product_table_item table {
	width: 100%;
}
</style>

<table id="opc_table_layout" class="one_page_product_list opc_manual_order_table" style="border-collapse: separate; margin-bottom:0 !important; width: 100%">
	<?php 
	$ign_opc->switch_user_context_to_customer( 'opc_user' );
	
	$decimal_places = wc_get_price_decimals();
	
	foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) { 
		// Make sure 
		$ign_opc->switch_user_context_to_customer( 'customer' );
	?>
	<tr class="one_page_product_table_item">
		<td colspan="5">
			<form action="" method="post" name="one_page_checkout_form" class="one_page_checkout_form opc_cart">
			
			<table style="border:none; border-collapse: separate; margin-bottom:0 !important"> 
			
			<?php 
			$_product   = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
			$product_id = apply_filters( 'woocommerce_cart_item_product_id', $cart_item['product_id'], $cart_item, $cart_item_key );
			$variation_id = $cart_item['variation_id']; 
			if ( version_compare( WOOCOMMERCE_VERSION, '2.4', '>=' ) )
				$type = $_product->get_type();
			else 
				$type = $_product->product_type;
				
			if ( $_product && $_product->exists() && $cart_item['quantity'] > 0 ) {

				$product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->get_permalink( $cart_item ), $cart_item, $cart_item_key );

				$attrs = $cart_item['data']->get_attributes();
				
				if ( empty( $attrs ) )
					$attrs = array();
					
				$data_attrs = $ign_opc_core->array_implode( '=', '&', $attrs );

				$class = ( 'simple' == $type ) ? 'opc_product_type_simple' : 'opc_product_type_variable';

				?>
				<tr class="<?php echo esc_attr( apply_filters( 'woocommerce_cart_item_class', 'cart_item', $cart_item, $cart_item_key ) ); ?>" cart_item_key="<?php echo $cart_item_key ?>">
				
					<td class="product-remove" style="width:2%;">
						<?php
							if ( function_exists( 'wc_get_cart_remove_url' ) )
								$remove_url = wc_get_cart_remove_url( $cart_item_key );
							else 
								$remove_url = WC()->cart->get_remove_url( $cart_item_key );
							
							// Removed the "remove" class name below to avoid theme conflicts
							$remove_link = apply_filters( 'woocommerce_cart_item_remove_link', sprintf(
								'<a href="%s" class="" title="%s" data-product_id="%s" data-product_sku="%s">&times;</a>',
								esc_url( $remove_url ),
								__( 'Remove this item', 'manual_phone_orders' ),
								esc_attr( $product_id ),
								esc_attr( $_product->get_sku() )
							), $cart_item_key );
							
							// Removed the "remove" class name below to avoid theme conflicts
							if ( false !== $pos = strpos( $remove_link, '<a' ) ) {
								$data = '<a data-product_id="' . $product_id . '" data-variation_id="' .  $variation_id . '"';
								$remove_link = preg_replace( '/<a/', $data, $remove_link );
								
								$data = 'class="opc_remove_from_cart ';
								$remove_link = preg_replace( '/class="/', $data, $remove_link );
							}
							
							echo $remove_link;
						?>
					</td>

					<td class="product-thumbnail" style="width:10%;">
						<?php
						$image = get_the_post_thumbnail( $product_id, apply_filters( 'single_product_large_thumbnail_size', 'shop_thumbnail' ), array() );
						
						if ( $image && !is_wp_error( $image ) ) {
							echo $image;
						} else {
							echo apply_filters( 'woocommerce_single_product_image_html', sprintf( '<img src="%s" alt="%s" style="width:75px" />', wc_placeholder_img_src(), __( 'Placeholder', 'manual_phone_orders' ) ), $product_id );
						}
	
						/* If you want the image linked to the single product page use this instead: 
						$thumbnail = apply_filters( 'woocommerce_cart_item_thumbnail', $_product->get_image(), $cart_item, $cart_item_key );

						if ( ! $product_permalink ) {
							echo $thumbnail;
						} else {
							printf( '<a href="%s" target="_blank">%s</a>', esc_url( $product_permalink ), $thumbnail );
						}
						*/
						?>
					</td>

					<td class="product-name" data-title="<?php _e( 'Product', 'manual_phone_orders' ); ?>" >
						<?php
						
						if ( version_compare( WOOCOMMERCE_VERSION, '3.0', '>=' ) ) { 
							$data = $ign_opc_core->get_product_name( $_product );
							$title = $data['name'];
						} else { 
							$title = $_product->get_title(); 
						}
							
						if ( ! $product_permalink ) {
							echo apply_filters( 'woocommerce_cart_item_name', $title, $cart_item, $cart_item_key ) . '&nbsp;';
						} else {
							echo apply_filters( 'woocommerce_cart_item_name', sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $title ), $cart_item, $cart_item_key );
						}

						// Meta data
						if ( function_exists( 'wc_get_formatted_cart_item_data' ) )
							$item_data = wc_get_formatted_cart_item_data( $cart_item );
						else 
							$item_data = WC()->cart->get_item_data( $cart_item );
							
						echo $item_data;

						// Backorder notification
						if ( $_product->backorders_require_notification() && $_product->is_on_backorder( $cart_item['quantity'] ) ) {
							echo '<p class="backorder_notification">' . esc_html__( 'Available on backorder', 'manual_phone_orders' ) . '</p>';
						}
						
						$price = $cart_item['data']->get_price();

						if ( null === $price || '' === $price ) {
							echo '<br/><span style="color:#bf0000">' . __( 'Product has no price, cannot be purchased', 'manual_phone_orders' ) . '</span>';
						}
						?>
					</td>

					<td class="product-price" data-title="<?php _e( 'Price', 'manual_phone_orders' ); ?>" style="width:30%;">
						<?php
						// Ask for product price so that plugins that don't display it can be detected 
						// by virtue of not returning a price. 
						//$the_price = apply_filters( 'woocommerce_cart_item_price', WC()->cart->get_product_price( $_product ), $cart_item, $cart_item_key ); 

						$ign_opc->switch_user_context_to_customer( 'customer' );
						
						if ( class_exists( 'IGN_Wholesale_Pro_Suite' ) && $ign_wholesale_pro_suite->get_filterable_role() ) { 
							// customer is user a wholesale buyer, get the wholesale price for the user
							$the_price = $ign_wholesale_pro_suite->maybe_return_price( '', $_product );
						/*
						} else if ( WC()->cart->display_prices_including_tax() ) {
							$the_price = wc_get_price_including_tax( $_product );
						} else {
							$the_price = wc_get_price_excluding_tax( $_product );
						}
						*/
						} else {
							$the_price = $_product->get_price();
						}

						$the_price_amt = $the_price;

						// $the_price = $_product->get_price();
						
						// $the_price plain :

						//$the_price_amt = strip_tags( $the_price ); 
						//$the_price_amt = str_replace( get_woocommerce_currency_symbol(), '', $the_price_amt );

						?>
						
						<div>
							<?php 
							if ( $ign_opc_core->user_can_change_price() && isset( $the_price ) && in_array( $type, array( 'simple', 'variation' ) ) ) { 	
								
								$ign_opc->switch_user_context_to_customer( 'customer' );
								
								// Get regular price, without any discounts or alterations hopefully
								$price = $cart_item['data']->get_regular_price( 'view' ); 
								
								$price_altered = isset( $cart_item['_price_altered'] ) ? $cart_item['_price_altered'] : ''; 

								if ( $price_altered == $the_price_amt ) {
									$price_altered = '';
								}

								// Display the regular price 
								if ( ( isset( $price_altered ) && '' !== $price_altered ) && ( floatval( $price ) !== floatval( $price_altered ) ) ) { 
								 
									$price = wc_format_decimal( $price, wc_get_price_decimals() );
									
									echo '<strike>' . wc_format_localized_price( $price ) . '</strike>&nbsp; ';
									
									$price_altered = wc_format_decimal( $price_altered, wc_get_price_decimals() );
									
									echo $price_altered;
									
									//$input_field_price = $price_altered;
									
								} else if ( '' !== $the_price && ( floatval( $price ) !== floatval( $the_price ) ) ) { 
								
									if ( $cart_item['data']->is_on_sale() ) {
										$price = wc_format_decimal( $price, wc_get_price_decimals() );
										echo '<strike>' .wc_format_localized_price( $price ) . '</strike>&nbsp; ';
									}
									
									$the_price = wc_format_decimal( $the_price, wc_get_price_decimals() );
									
									echo wc_format_localized_price( $the_price );
									
									//$input_field_price = $the_price;
									
								} else { 
								
									$price = wc_format_decimal( $price, wc_get_price_decimals() );
									
									echo wc_format_localized_price( $price );
									
									// remove this code to leave the price field empty unless it was changed intentionally	
									//$input_field_price = $price;
								}

								echo '&nbsp;';
								
								$the_price_amt = wc_format_localized_price( $the_price_amt );
								
								// Store the price in a hidden field. Then display a field where the price can be changed. 
								// When changed the hidden opc_price field is updated via JS since it is used as the product price. 
								// If this field isn't changed then all other pricing filters operate as expected,
								// or if this field IS changed then phone/manual orders should in theory be able to enforce the edited price since its filters
								// try to run last among all price filters on a site.
								?>
								<input type="hidden" class="small opc_price" value="<?php echo $the_price_amt ?>">
								
								<input type="hidden" class="small opc_regular_price" value="<?php echo $the_price_amt ?>">
								
								<?php /*if ( !empty( $price_altered ) && ( floatval( $price ) !== floatval( $price_altered ) ) ) { 
									$input_field_price = $price_altered;
								} else if ( !empty( $the_price ) && ( floatval( $price ) !== floatval( $the_price ) ) ) { 
									$input_field_price = $the_price;
								} else { 
									$input_field_price = $price;
								}
								*/

								$input_field_price = $price_altered;

								if ( !empty( $input_field_price ) ) { 
									$input_field_price = wc_format_decimal( $input_field_price, $decimal_places );
									$input_field_price = wc_format_localized_price( $input_field_price );
								}

								?>
								<input type="text" class="small opc_changeable_price" value="<?php echo $input_field_price ?>" title="<?php _e( 'To change the price enter the price here without tax', 'manual_phone_orders' )?>">
								
								<div class="price_change_helptip"><?php echo wc_help_tip( __( 'To change the price enter the price here without tax', 'manual_phone_orders' ) ) ?></div>
							<?php 
							} else {

								$ign_opc->switch_user_context_to_customer( 'customer' );
							
								$price = apply_filters( 'woocommerce_cart_item_price', WC()->cart->get_product_price( $_product ), $cart_item, $cart_item_key );
							
								echo wc_format_localized_price( $price ); 
							}
							?>
							
						</div>
					</td>

					<td class="product-quantity" data-title="<?php _e( 'Quantity', 'manual_phone_orders' ); ?>" style="width:15%;">
						<?php  if ( in_array( $type, array( 'simple', 'variation' ) ) ) {
						
							$ign_opc->switch_user_context_to_customer( 'customer' );
						
							if ( !empty( $ign_opc_core->settings['enforce_min_max_step'] ) && 'yes' == $ign_opc_core->settings['enforce_min_max_step'] ) { 
								$min_value = apply_filters( 'woocommerce_quantity_input_min', 1, $cart_item['data'] );

								// -1 here means unlimited
								$max_value = apply_filters( 'woocommerce_quantity_input_max', -1, $cart_item['data'] );

								$step = apply_filters( 'woocommerce_quantity_input_step', 1, $cart_item['data'] );
								
							} else {
								
								$min_value = 1;
								
								$max_value = -1;
								
								$step = 1;
							}
							
							$qty = IGN_Manual_Phone_Orders_Core::get_qty_in_cart( $product_id, $variation_id, $cart_item_key );
							
							$max = method_exists( $_product, 'get_max_purchase_quantity' ) ? $_product->get_max_purchase_quantity() : $_product->get_stock_quantity();

							if ( absint( $cart_item['quantity'] ) < absint( $min_value ) ) { 
								$quantity = $min_value;
							} else { 
								$quantity = $cart_item['quantity'];
							}
							
							$product_quantity = woocommerce_quantity_input( array(
								'input_name'  => "cart[{$cart_item_key}][qty]",
								'input_value' => $quantity,
								'max_value'   => $max_value,
								'min_value'   => $min_value,
								'step' => $step,
							), $_product, false );
							
							// Add data attributes for JS
							if ( false !== $pos = strpos( $product_quantity, '<input' ) ) {
								
								//$data = '<input data-product_id="' . $product_id . '" data-variation_id="' .  $variation_id . '" data-attributes="' . esc_html( $data_attrs ) . '"';
								
								// Ryder Ross contributed this tweak, handles attributes with $ followed by numbers
								$escaped_attrs = preg_replace('/\$(\d)/', '\\\$$1', esc_html($data_attrs));
								
								
								$data = '<input data-product_id="' . $product_id . '" data-variation_id="' .  $variation_id . '" data-attributes="' . $escaped_attrs . '" data-cart_item_key="' . $cart_item_key . '"';

								$product_quantity = preg_replace( '/<input/', $data, $product_quantity );
							}
							
							echo apply_filters( 'woocommerce_cart_item_quantity', $product_quantity, $cart_item_key, $cart_item );
							
						} else { 
							echo $cart_item['quantity'];
						}
						?>
					</td>
				</tr>
				<?php } ?>
			</table>
			</form>
		</td>
	<?php } ?>
	</tr>
</table>

<div class="cart_contents_buttons" style="text-align:right">
	<input type="button" class="clear_entire_cart button" value="<?php _e( 'Clear entire cart', 'manual_phone_orders' ) ?>" />
	<?php if ( !empty( $ign_opc_core->settings['disable_autorefresh'] ) && 'yes' == $ign_opc_core->settings['disable_autorefresh'] ) { ?>
		<input type="button" class="update_the_cart_totals_cart button" value="<?php _e( 'Update cart totals', 'manual_phone_orders' ) ?>" />
	<?php } ?>
</div>
<?php /*
<script>
jQuery( document ).ready( function() { 
	//one_page_remove_from_cart();
})
</script>
*/
